# -------------------------------------------------------------------------
# display.pm, authored by paal@ekran.no, Mon Aug 28 11:44:40 CEST 2000

#
# handle everythings that relates to displaying messages on the screen, this
# is considered to be the main view, a split screen with messages info at
# the top and message printout at the bottom.
#

# -------------------------------------------------------------------
# display messages in current box
sub display_headers()
{
    my $cnt;
    my $col;

    print '<br><center><b>'.$c_fontL;
    display_handle_change_folders();
    print '</b></center>'."\n";

    print '<form action="webmh.cgi" target="F1">'."\n";
    print '<table border=0 width="80%" align="center"
                bgcolor="'.$c_backdrop.'">'."\n";
    print '<tr>
               <th>'.$c_fontL.'#</font></th>
               <th>'.$c_fontL.'mark</font></th>
               <th>'.$c_fontL.'Date</font></th>
               <th align=left>'.$c_fontL.'From/Subject</font></th>
               </tr>';

    $cnt=0;
    open TXT,$i_nmh."/scan -width 200 -reverse all -form ".$i_wmhome."/scan.main |";
    while ($line=<TXT>)
    {
        chomp $line;
        ($id,$stat,$dt,$from,$subj)=split /WMHsplit42/,$line;
		if ($stat eq "()") {$stat=""}

        if (++$cnt/2==(int($cnt/2))) # change colours every second line
        {
            $col=$c_backdrop_r;
        } else {
            $col=$c_backdrop_l;
        }

		$id=int($id); # convert to int and write mail info for each message
        print '<tr>
               <td bgcolor="'.$col.'" align="center">'.$c_fontL.$id.'</td>
               <td bgcolor="'.$col.'" align="center">
                    <input type="checkbox" name="d'.$id.'"></td>
               <td bgcolor="'.$col.'" align="center">'.$c_fontL.$dt.$c_fontL.$stat.'</td>
               <td bgcolor="'.$col.'" align="left" width="75%"><font size="-1">
                <b>'.$c_fontL.$from.'</b><br>
                <a href="webmh.cgi?USHOW='.int($id).'&UACT=mtail" target="F2">'.
                $c_fontL.html_encode($subj).'</td>
                </tr>';
    }
    close TXT;

    print '<tr><th colspan=4>'."\n";

    print '<table align="center" width="100%"><tr>
            <td align="left">'.$c_fontL.'
                <input type="submit" name="delMarked"
                    value="Delete marked messages"></td>
            <td align="right">'.$c_fontL;

    display_single_folder_move_selector("Move marked messages to:","movMarked");

    print '     </b></td>
           </tr></table>
           </th></tr></table>';
    print '</form>';
}


# -------------------------------------------------------------------
# display a message (input parameter is message number)
sub display_message()
{
    my ($mno)=@_;
    my $chk,$cnt;
    my $nempty;

    if (!$ushow) { ($ushow)=get_current_message(); }
    print '<br><table width="100%" border="0"
                cellspacing="0" cellpadding="0" bgcolor="'.$c_backdrop.'">
            <tr><td>'.$c_fontBar.'Message No. ';

    $nempty=1; # i.e. there is a current message

    if (!($ushow)) {
        print "[ none selected ]"; $nempty=0; # no current message
    } else { print $ushow; }

    print '</font></td><td align=right>'.$c_fontBar;
    if ($nempty) { # only write reply, forward, etc if there is a message
        print ' [ <a href="webmh.cgi?UACT=compose&USHOW=1&UFLAG=R"
                    target="_top">reply</a> ]
                [ <a href="webmh.cgi?UACT=compose&USHOW=1&UFLAG=F"
                    target="_top">forward</a> ]
                [ <a href="webmh.cgi?UACT=compose&USHOW=2&UFLAG=G"
					target="_top">group-reply</a> ]
                [ <a href="webmh.cgi?UACT=compose&USHOW=1&UFLAG=B"
                    target="_top">bounce</a> ]
                </font>';
    } else { print '&nbsp;'; }

    print ' </td></tr></table>
            <ul><pre><b>';

    $chk=0; $cnt=0;
    $state=tools_expanded($unam);

    if ($ups) {
        print $c_fontBar."<p><br><center>".$ups.'</center><br>';
    }

    open TXT,$i_nmh."/show -noheader -noshowproc ".$mno." |";
    while ($line=<TXT>)
    {
        chomp $line;
        if ($chk==0) # $chk==0 => we're in the header
        {
            if ($line eq "") # empty line? => end of header
            {
                if (!($state))
                {
                    print '[ <a href="'.$cgi_url.
                        'webmh.cgi?UACT=expand" target="_top">expand</a> ]</b>';
                } else {
                    print '[ <a href="'.$cgi_url.
                        'webmh.cgi?UACT=shrink" target="_top">shrink</a> ]</b>';
                }
                print "\n\n";
                $chk=1;
            }

            $_=$line; # for the /^ search line
            if ($state) # write header information
            {
                print html_encode($line)."\n";
            } elsif (/^From:/ || /^Subject:/ || /^Date:/ || /^To:/) {
                print html_encode($line)."\n";
            }

        } else {
            print html_encode($line)."\n";
        }

    }
    close TXT;
    print '</pre></ul>';

    print '<table width="100%" border="0"
                cellspacing="0" cellpadding="0" bgcolor="'.$c_backdrop.'">
            <tr><td align=left>'.$c_fontL;

    if ($nempty) # only write move/delete if there is a message
    {
        print '<b>';
        display_single_folder_move_selector("&nbsp;Move to","movs");
        print '</b></td><td align=right>'.$c_fontBar.'
    [ <a href="webmh.cgi?UACT=dels&USHOW='.$ushow.'" target="_top">delete</a> ]
                &nbsp;';
    } else { print '&nbsp;<br>'; }

    print '</td></tr></table><br>'."\n";
}

# ----------------------------------------------------------------------
# display the change folder box at the top of the display message screen
sub display_handle_change_folders()
{
    my @folders;
    my $pf,$pfc;

    print '<form action="webmh.cgi" target="_top">';
    open TXT,$i_nmh.'/folders -noheader -nototal -recurse |';
    while (<TXT>)
    {
        chomp;
        push @folders,$_; # make a list of all the folders
    }
    close TXT;

    print 'Change to folder: <select name="SFOLDER">';
    ($current)=get_current_folder();
    ($pfc)=get_plain_folder($current,$current);
    print '<option value="'.$pfc.'">'.$current.' '."\n";
    foreach $line (@folders)
    {
        ($pf)=get_plain_folder($line,$current);
        if ($pf ne $pfc)
        {
            print '<option value="'.$pf.'">'.$line.' '."\n";
        }
    }
    print '</select>
            <input type="submit" name="CFOLDER" value="ok">
            </form>';
}

# ----------------------------------------------------------------------
# display_single_folder_move_selector
sub display_single_folder_move_selector()
{
    ($atext,$act)=@_; # atext=output infront of selector, $act=action for $uact

    my @folders;

    open TXT,$i_nmh.'/folders -noheader -nototal -recurse |';
    while (<TXT>)
    {
        chomp;
        push @folders,$_; # make a list of all the folders
    }
    close TXT;

    if (($act ne "movMarked") && ($act ne 'mini'))
	{
		print '<form action="webmh.cgi" target="_top" method="GET">';
	}

	print $atext; # optional text before the selection
    print '<select name="SFOLDER">';

    ($current)=get_current_folder();

	# hack to avoid user deletion of inbox.
	if ($act eq 'mini') { $current='inbox+ has n messages (n-n)'; }

    ($pfc)=get_plain_folder($current,$current);
    foreach $line (@folders)
    {
        ($pf)=get_plain_folder($line,$current);
        if ($pf ne $pfc) # don't print the current folder.
        {
            print '<option value="'.$pf.'">'.$pf.' '."\n";
        }
    }
    print '</select>';

	if ($act ne "mini")
	{
		print '<input type="hidden" name="UACT" value="'.$act.'">';
        print '<input type="submit" value="ok">';
	}

	print "\n";
}

1;
